
_set_up:

;digital_clock.c,8 :: 		void set_up() {   //function for pic16f887
;digital_clock.c,10 :: 		ANSEL = 0;      //all the pins are configured as digital I/O
	CLRF       ANSEL+0
;digital_clock.c,11 :: 		ANSELH = 0;
	CLRF       ANSELH+0
;digital_clock.c,12 :: 		C1ON_bit = 0;    //analog comparators off.
	BCF        C1ON_bit+0, BitPos(C1ON_bit+0)
;digital_clock.c,13 :: 		C2ON_bit = 0;
	BCF        C2ON_bit+0, BitPos(C2ON_bit+0)
;digital_clock.c,14 :: 		CCP1CON = 0;   //PWM1 y PWM2 off.
	CLRF       CCP1CON+0
;digital_clock.c,15 :: 		CCP2CON = 0;
	CLRF       CCP2CON+0
;digital_clock.c,16 :: 		TRISB = 0;
	CLRF       TRISB+0
;digital_clock.c,17 :: 		TRISD = 0;
	CLRF       TRISD+0
;digital_clock.c,18 :: 		TRISC = 0xF0;   //RC7, RC6, RC5 and RC4 are configured as digital inputs
	MOVLW      240
	MOVWF      TRISC+0
;digital_clock.c,19 :: 		PORTB = 0;     //clear Ports B, C and D
	CLRF       PORTB+0
;digital_clock.c,20 :: 		PORTC = 0;
	CLRF       PORTC+0
;digital_clock.c,21 :: 		PORTD = 0;
	CLRF       PORTD+0
;digital_clock.c,22 :: 		}
L_end_set_up:
	RETURN
; end of _set_up

_reloj:

;digital_clock.c,24 :: 		void reloj() {
;digital_clock.c,27 :: 		unsigned char display[10] = {63,6,91,79,102,109,125,7,127,103};
	MOVLW      63
	MOVWF      reloj_display_L0+0
	MOVLW      6
	MOVWF      reloj_display_L0+1
	MOVLW      91
	MOVWF      reloj_display_L0+2
	MOVLW      79
	MOVWF      reloj_display_L0+3
	MOVLW      102
	MOVWF      reloj_display_L0+4
	MOVLW      109
	MOVWF      reloj_display_L0+5
	MOVLW      125
	MOVWF      reloj_display_L0+6
	MOVLW      7
	MOVWF      reloj_display_L0+7
	MOVLW      127
	MOVWF      reloj_display_L0+8
	MOVLW      103
	MOVWF      reloj_display_L0+9
	CLRF       reloj_i_L0+0
;digital_clock.c,29 :: 		for(i=0; i<=86; i++){  // aprox 1 seg
	CLRF       reloj_i_L0+0
L_reloj0:
	MOVLW      128
	XORLW      86
	MOVWF      R0+0
	MOVLW      128
	XORWF      reloj_i_L0+0, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 0
	GOTO       L_reloj1
;digital_clock.c,30 :: 		ch0 = horas/10;
	MOVLW      10
	MOVWF      R4+0
	MOVF       _horas+0, 0
	MOVWF      R0+0
	CALL       _Div_8X8_U+0
;digital_clock.c,31 :: 		PORTD = 1;
	MOVLW      1
	MOVWF      PORTD+0
;digital_clock.c,32 :: 		PORTB = display[ch0] ;
	MOVF       R0+0, 0
	ADDLW      reloj_display_L0+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      PORTB+0
;digital_clock.c,33 :: 		delay_ms(2);             //Hours
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_reloj3:
	DECFSZ     R13+0, 1
	GOTO       L_reloj3
	DECFSZ     R12+0, 1
	GOTO       L_reloj3
	NOP
	NOP
;digital_clock.c,34 :: 		ch1 = horas%10;
	MOVLW      10
	MOVWF      R4+0
	MOVF       _horas+0, 0
	MOVWF      R0+0
	CALL       _Div_8X8_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
;digital_clock.c,35 :: 		PORTD = 2;
	MOVLW      2
	MOVWF      PORTD+0
;digital_clock.c,36 :: 		PORTB = display[ch1] ;
	MOVF       R0+0, 0
	ADDLW      reloj_display_L0+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      PORTB+0
;digital_clock.c,37 :: 		delay_ms(2);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_reloj4:
	DECFSZ     R13+0, 1
	GOTO       L_reloj4
	DECFSZ     R12+0, 1
	GOTO       L_reloj4
	NOP
	NOP
;digital_clock.c,38 :: 		ch2 = minutos/10;
	MOVLW      10
	MOVWF      R4+0
	MOVF       _minutos+0, 0
	MOVWF      R0+0
	CALL       _Div_8X8_U+0
;digital_clock.c,39 :: 		PORTD = 4;              //Minutes
	MOVLW      4
	MOVWF      PORTD+0
;digital_clock.c,40 :: 		PORTB = display[ch2] ;
	MOVF       R0+0, 0
	ADDLW      reloj_display_L0+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      PORTB+0
;digital_clock.c,41 :: 		delay_ms(2);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_reloj5:
	DECFSZ     R13+0, 1
	GOTO       L_reloj5
	DECFSZ     R12+0, 1
	GOTO       L_reloj5
	NOP
	NOP
;digital_clock.c,42 :: 		ch3=  minutos%10;
	MOVLW      10
	MOVWF      R4+0
	MOVF       _minutos+0, 0
	MOVWF      R0+0
	CALL       _Div_8X8_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
;digital_clock.c,43 :: 		PORTD = 8;
	MOVLW      8
	MOVWF      PORTD+0
;digital_clock.c,44 :: 		PORTB = display[ch3] ;
	MOVF       R0+0, 0
	ADDLW      reloj_display_L0+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      PORTB+0
;digital_clock.c,45 :: 		delay_ms(2);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_reloj6:
	DECFSZ     R13+0, 1
	GOTO       L_reloj6
	DECFSZ     R12+0, 1
	GOTO       L_reloj6
	NOP
	NOP
;digital_clock.c,46 :: 		ch4 = segundos/10;
	MOVLW      10
	MOVWF      R4+0
	MOVF       _segundos+0, 0
	MOVWF      R0+0
	CALL       _Div_8X8_U+0
;digital_clock.c,47 :: 		PORTD = 16;              //Seconds
	MOVLW      16
	MOVWF      PORTD+0
;digital_clock.c,48 :: 		PORTB = display[ch4] ;
	MOVF       R0+0, 0
	ADDLW      reloj_display_L0+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      PORTB+0
;digital_clock.c,49 :: 		delay_ms(2);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_reloj7:
	DECFSZ     R13+0, 1
	GOTO       L_reloj7
	DECFSZ     R12+0, 1
	GOTO       L_reloj7
	NOP
	NOP
;digital_clock.c,50 :: 		ch5 = segundos%10;
	MOVLW      10
	MOVWF      R4+0
	MOVF       _segundos+0, 0
	MOVWF      R0+0
	CALL       _Div_8X8_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
;digital_clock.c,51 :: 		PORTD = 32;
	MOVLW      32
	MOVWF      PORTD+0
;digital_clock.c,52 :: 		PORTB = display[ch5] ;
	MOVF       R0+0, 0
	ADDLW      reloj_display_L0+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      PORTB+0
;digital_clock.c,53 :: 		delay_ms(2);
	MOVLW      3
	MOVWF      R12+0
	MOVLW      151
	MOVWF      R13+0
L_reloj8:
	DECFSZ     R13+0, 1
	GOTO       L_reloj8
	DECFSZ     R12+0, 1
	GOTO       L_reloj8
	NOP
	NOP
;digital_clock.c,29 :: 		for(i=0; i<=86; i++){  // aprox 1 seg
	INCF       reloj_i_L0+0, 1
;digital_clock.c,54 :: 		}
	GOTO       L_reloj0
L_reloj1:
;digital_clock.c,55 :: 		}
L_end_reloj:
	RETURN
; end of _reloj

_main:

;digital_clock.c,57 :: 		void main() {
;digital_clock.c,58 :: 		set_up();
	CALL       _set_up+0
;digital_clock.c,59 :: 		do {
L_main9:
;digital_clock.c,60 :: 		reloj();
	CALL       _reloj+0
;digital_clock.c,61 :: 		segundos++;
	INCF       _segundos+0, 1
;digital_clock.c,62 :: 		if(segundos>59) segundos=0, minutos++;
	MOVF       _segundos+0, 0
	SUBLW      59
	BTFSC      STATUS+0, 0
	GOTO       L_main12
	CLRF       _segundos+0
	INCF       _minutos+0, 1
L_main12:
;digital_clock.c,63 :: 		if(minutos>59) minutos=0,  horas++;
	MOVF       _minutos+0, 0
	SUBLW      59
	BTFSC      STATUS+0, 0
	GOTO       L_main13
	CLRF       _minutos+0
	INCF       _horas+0, 1
L_main13:
;digital_clock.c,64 :: 		if(horas>23) horas=0;
	MOVF       _horas+0, 0
	SUBLW      23
	BTFSC      STATUS+0, 0
	GOTO       L_main14
	CLRF       _horas+0
L_main14:
;digital_clock.c,66 :: 		if (Button(&PORTC,6,1,0)) e1=0;     //if the button has been pushed
	MOVLW      PORTC+0
	MOVWF      FARG_Button_port+0
	MOVLW      6
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main15
	CLRF       _e1+0
L_main15:
;digital_clock.c,67 :: 		if (e1==0 && Button(&PORTC,6,1,1)){ //and if after that the button is free
	MOVF       _e1+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main18
	MOVLW      PORTC+0
	MOVWF      FARG_Button_port+0
	MOVLW      6
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main18
L__main38:
;digital_clock.c,68 :: 		minutos++;                          //then increase minutos
	INCF       _minutos+0, 1
;digital_clock.c,69 :: 		if (minutos>59) minutos=0;
	MOVF       _minutos+0, 0
	SUBLW      59
	BTFSC      STATUS+0, 0
	GOTO       L_main19
	CLRF       _minutos+0
L_main19:
;digital_clock.c,70 :: 		segundos=0;
	CLRF       _segundos+0
;digital_clock.c,71 :: 		e1=1;
	MOVLW      1
	MOVWF      _e1+0
;digital_clock.c,72 :: 		}
L_main18:
;digital_clock.c,73 :: 		if (Button(&PORTC,7,1,0)) e0=0;     //if the button has been pushed
	MOVLW      PORTC+0
	MOVWF      FARG_Button_port+0
	MOVLW      7
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main20
	CLRF       _e0+0
L_main20:
;digital_clock.c,74 :: 		if (e0==0 && Button(&PORTC,7,1,1)){ //and if after that the button is free
	MOVF       _e0+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main23
	MOVLW      PORTC+0
	MOVWF      FARG_Button_port+0
	MOVLW      7
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main23
L__main37:
;digital_clock.c,75 :: 		minutos--;                          //then decrease minutos
	DECF       _minutos+0, 1
;digital_clock.c,76 :: 		if (minutos==255) minutos=59;       // -1=255 >>>>> 0
	MOVF       _minutos+0, 0
	XORLW      255
	BTFSS      STATUS+0, 2
	GOTO       L_main24
	MOVLW      59
	MOVWF      _minutos+0
L_main24:
;digital_clock.c,77 :: 		segundos=0;
	CLRF       _segundos+0
;digital_clock.c,78 :: 		e0=1;
	MOVLW      1
	MOVWF      _e0+0
;digital_clock.c,79 :: 		}
L_main23:
;digital_clock.c,80 :: 		if (Button(&PORTC,4,1,0)) e2=0;       //if the button has been pushed
	MOVLW      PORTC+0
	MOVWF      FARG_Button_port+0
	MOVLW      4
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main25
	CLRF       _e2+0
L_main25:
;digital_clock.c,81 :: 		if (e2==0 && Button(&PORTC,4,1,1)){ //and if after that the button is free
	MOVF       _e2+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main28
	MOVLW      PORTC+0
	MOVWF      FARG_Button_port+0
	MOVLW      4
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main28
L__main36:
;digital_clock.c,82 :: 		horas++;                            //then increase horas
	INCF       _horas+0, 1
;digital_clock.c,83 :: 		if (horas>23) horas=0;
	MOVF       _horas+0, 0
	SUBLW      23
	BTFSC      STATUS+0, 0
	GOTO       L_main29
	CLRF       _horas+0
L_main29:
;digital_clock.c,84 :: 		segundos=0;
	CLRF       _segundos+0
;digital_clock.c,85 :: 		e2=1;
	MOVLW      1
	MOVWF      _e2+0
;digital_clock.c,86 :: 		}
L_main28:
;digital_clock.c,87 :: 		if (Button(&PORTC,5,1,0)) e3=0;     //if the button has been pushed
	MOVLW      PORTC+0
	MOVWF      FARG_Button_port+0
	MOVLW      5
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main30
	CLRF       _e3+0
L_main30:
;digital_clock.c,88 :: 		if (e3==0 && Button(&PORTC,5,1,1)){ //and if after that the button is free
	MOVF       _e3+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main33
	MOVLW      PORTC+0
	MOVWF      FARG_Button_port+0
	MOVLW      5
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main33
L__main35:
;digital_clock.c,89 :: 		horas--;                            //then decrease horas
	DECF       _horas+0, 1
;digital_clock.c,90 :: 		if (horas==255) horas=23;          // -1=255 >>>>> 0
	MOVF       _horas+0, 0
	XORLW      255
	BTFSS      STATUS+0, 2
	GOTO       L_main34
	MOVLW      23
	MOVWF      _horas+0
L_main34:
;digital_clock.c,91 :: 		segundos=0;
	CLRF       _segundos+0
;digital_clock.c,92 :: 		e3=1;
	MOVLW      1
	MOVWF      _e3+0
;digital_clock.c,93 :: 		}
L_main33:
;digital_clock.c,94 :: 		} while(1);
	GOTO       L_main9
;digital_clock.c,95 :: 		} //END.
L_end_main:
	GOTO       $+0
; end of _main
